From f91b4833193e1d883b3fcc0d1972c04b7057315f Mon Sep 17 00:00:00 2001
From: halfspawn <j.brauge@qualiac.com>
Date: Thu, 30 Mar 2017 20:44:35 +0200
Subject: [PATCH] Add info provide by jdbc client to
 information_schema.processlist

---
 mysql-test/r/create.result                         |  10 +-
 mysql-test/r/information_schema_processlist.result |  49 +++++++
 mysql-test/suite/funcs_1/r/is_columns_is.result    |   6 +
 .../funcs_1/r/processlist_priv_no_prot.result      | 146 +++++++++++----------
 .../suite/funcs_1/r/processlist_val_no_prot.result |  49 +++----
 mysql-test/t/information_schema_processlist.test   |  42 ++++++
 sql/sql_show.cc                                    |  72 +++++++++-
 sql/sql_show.h                                     |   2 +
 8 files changed, 280 insertions(+), 96 deletions(-)
 create mode 100644 mysql-test/r/information_schema_processlist.result
 create mode 100644 mysql-test/t/information_schema_processlist.test

diff --git a/mysql-test/r/create.result b/mysql-test/r/create.result
index 81b65c4..763abed 100644
--- a/mysql-test/r/create.result
+++ b/mysql-test/r/create.result
@@ -1154,7 +1154,10 @@ t1	CREATE TABLE `t1` (
   `EXAMINED_ROWS` int(7) NOT NULL DEFAULT 0,
   `QUERY_ID` bigint(4) NOT NULL DEFAULT 0,
   `INFO_BINARY` blob DEFAULT NULL,
-  `TID` bigint(4) NOT NULL DEFAULT 0
+  `TID` bigint(4) NOT NULL DEFAULT 0,
+  `APPLICATION_NAME` varchar(64) DEFAULT NULL,
+  `CLIENT_USER` varchar(128) DEFAULT NULL,
+  `CLIENT_HOSTNAME` varchar(64) DEFAULT NULL
 )  DEFAULT CHARSET=utf8
 drop table t1;
 create temporary table t1 like information_schema.processlist;
@@ -1177,7 +1180,10 @@ t1	CREATE TEMPORARY TABLE `t1` (
   `EXAMINED_ROWS` int(7) NOT NULL DEFAULT 0,
   `QUERY_ID` bigint(4) NOT NULL DEFAULT 0,
   `INFO_BINARY` blob DEFAULT NULL,
-  `TID` bigint(4) NOT NULL DEFAULT 0
+  `TID` bigint(4) NOT NULL DEFAULT 0,
+  `APPLICATION_NAME` varchar(64) DEFAULT NULL,
+  `CLIENT_USER` varchar(128) DEFAULT NULL,
+  `CLIENT_HOSTNAME` varchar(64) DEFAULT NULL
 )  DEFAULT CHARSET=utf8
 drop table t1;
 create table t1 like information_schema.character_sets;
diff --git a/mysql-test/r/information_schema_processlist.result b/mysql-test/r/information_schema_processlist.result
new file mode 100644
index 0000000..acbc37a
--- /dev/null
+++ b/mysql-test/r/information_schema_processlist.result
@@ -0,0 +1,49 @@
+#
+# MDEV-????? Add fields Application_Name, Client_User et Client_Hostname
+#            to information_schema.processlist
+#            To set these columns, two ways :
+#                via JDBC :
+#                     cnx.setClientInfo("ApplicationName",value)
+#                     cnx.setClientInfo("ClientUser",value)
+#                     cnx.setClientInfo("ClientHostname",value)
+#                via set session variables :
+#                     set @ApplicationName=value (64 char max)
+#                     set @ClientUser=value      (128 char max)
+#                     set @ClientHostname=value  (64 char max)
+# Variables not set.
+select application_name, client_user, client_hostname from information_schema.processlist where id=con_id;
+application_name	client_user	client_hostname
+NULL	NULL	NULL
+select count(*) from information_schema.processlist where application_name is null;
+count(*)
+1
+# All variables not set.
+set @ApplicationName='TestApp';
+set @ClientUser='Developper';
+set @ClientHostname='my PC';
+select application_name, client_user, client_hostname from information_schema.processlist where id=con_id;
+application_name	client_user	client_hostname
+TestApp	Developper	my PC
+select count(*) from information_schema.processlist where application_name is null;
+count(*)
+0
+# Reset variables to null
+set @ApplicationName=null;
+set @ClientUser=null;
+set @ClientHostname=null;
+select application_name, client_user, client_hostname from information_schema.processlist where id=con_id;
+application_name	client_user	client_hostname
+NULL	NULL	NULL
+select count(*) from information_schema.processlist where application_name is null;
+count(*)
+1
+# Set value too long
+set @ApplicationName='aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa';
+set @ClientUser='aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa';
+set @ClientHostname='aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa';
+select application_name, client_user, client_hostname from information_schema.processlist where id=con_id;
+application_name	client_user	client_hostname
+aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa	aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa	aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa
+select length(application_name), length(client_user), length(client_hostname) from information_schema.processlist where application_name is not null;
+length(application_name)	length(client_user)	length(client_hostname)
+64	128	64
diff --git a/mysql-test/suite/funcs_1/r/is_columns_is.result b/mysql-test/suite/funcs_1/r/is_columns_is.result
index 9cf3478..03cc32e 100644
--- a/mysql-test/suite/funcs_1/r/is_columns_is.result
+++ b/mysql-test/suite/funcs_1/r/is_columns_is.result
@@ -254,6 +254,9 @@ def	information_schema	PLUGINS	PLUGIN_STATUS	3		NO	varchar	16	48	NULL	NULL	NULL
 def	information_schema	PLUGINS	PLUGIN_TYPE	4		NO	varchar	80	240	NULL	NULL	NULL	utf8	utf8_general_ci	varchar(80)			select		NEVER	NULL
 def	information_schema	PLUGINS	PLUGIN_TYPE_VERSION	5		NO	varchar	20	60	NULL	NULL	NULL	utf8	utf8_general_ci	varchar(20)			select		NEVER	NULL
 def	information_schema	PLUGINS	PLUGIN_VERSION	2		NO	varchar	20	60	NULL	NULL	NULL	utf8	utf8_general_ci	varchar(20)			select		NEVER	NULL
+def	information_schema	PROCESSLIST	APPLICATION_NAME	18	NULL	YES	varchar	64	192	NULL	NULL	NULL	utf8	utf8_general_ci	varchar(64)			select		NEVER	NULL
+def	information_schema	PROCESSLIST	CLIENT_HOSTNAME	20	NULL	YES	varchar	64	192	NULL	NULL	NULL	utf8	utf8_general_ci	varchar(64)			select		NEVER	NULL
+def	information_schema	PROCESSLIST	CLIENT_USER	19	NULL	YES	varchar	128	384	NULL	NULL	NULL	utf8	utf8_general_ci	varchar(128)			select		NEVER	NULL
 def	information_schema	PROCESSLIST	COMMAND	5		NO	varchar	16	48	NULL	NULL	NULL	utf8	utf8_general_ci	varchar(16)			select		NEVER	NULL
 def	information_schema	PROCESSLIST	DB	4	NULL	YES	varchar	64	192	NULL	NULL	NULL	utf8	utf8_general_ci	varchar(64)			select		NEVER	NULL
 def	information_schema	PROCESSLIST	EXAMINED_ROWS	14	0	NO	int	NULL	NULL	10	0	NULL	NULL	NULL	int(7)			select		NEVER	NULL
@@ -801,6 +804,9 @@ NULL	information_schema	PROCESSLIST	EXAMINED_ROWS	int	NULL	NULL	NULL	NULL	int(7)
 NULL	information_schema	PROCESSLIST	QUERY_ID	bigint	NULL	NULL	NULL	NULL	bigint(4)
 1.0000	information_schema	PROCESSLIST	INFO_BINARY	blob	65535	65535	NULL	NULL	blob
 NULL	information_schema	PROCESSLIST	TID	bigint	NULL	NULL	NULL	NULL	bigint(4)
+3.0000	information_schema	PROCESSLIST	APPLICATION_NAME	varchar	64	192	utf8	utf8_general_ci	varchar(64)
+3.0000	information_schema	PROCESSLIST	CLIENT_USER	varchar	128	384	utf8	utf8_general_ci	varchar(128)
+3.0000	information_schema	PROCESSLIST	CLIENT_HOSTNAME	varchar	64	192	utf8	utf8_general_ci	varchar(64)
 3.0000	information_schema	REFERENTIAL_CONSTRAINTS	CONSTRAINT_CATALOG	varchar	512	1536	utf8	utf8_general_ci	varchar(512)
 3.0000	information_schema	REFERENTIAL_CONSTRAINTS	CONSTRAINT_SCHEMA	varchar	64	192	utf8	utf8_general_ci	varchar(64)
 3.0000	information_schema	REFERENTIAL_CONSTRAINTS	CONSTRAINT_NAME	varchar	64	192	utf8	utf8_general_ci	varchar(64)
